// Kyle Burmark
// 4/19/02
// Header defintion file for list.cpp

// Check for redefinition

#ifndef LIST_H
#define LIST_H

#include "node.h"
#include <cstdlib>

// using modified code from main savitch c++ programming book


// Class

class list
{
public:
    
////////////////////////// Typedefs /////////////////////////////////
    
    typedef size_t size_type;	// Rename size_t as 
				// size_type
    typedef node::value_type value_type;    // Make the node's class
					    // value_type the same as
					    // this class' value_type
    
///////////////////// Constructors ////////////////////////////////
    
    list();
    
////////////////////////// Mutators ////////////////////////////////
    
    // Add a name to a flight
    
    void add(const value_type entry);
    
    // Delete a name from a flight
    
    void del(const value_type target);
    
    //////////////////////////// Accesors //////////////////////////
    
    // Get list of names on certain flight
    
    void getlist() const;
    
    // Get number of passengers on flight
    
    void getnum() const;
    
/////////////////////////// Destructor /////////////////////////////
    
    ~list();
    
private:
    node *head_ptr;	    // list head pointer
    node *previous_ptr;	    // Pointer of where to add or delete a node
    size_type many_nodes;   // number of nodes in list
    
    
};

#endif // End LIST_H
