#include <iomanip.h>
#include <string.h>


class Student
{
	char id[15];
	char name[30];
	int mark;

public:

	Student(char *a = "",char *b="",int c=0)
	{
		strcpy(id,a);
		strcpy(name,b);
		mark=c;
	}

	void operator=(const Student &s)
	{
		strcpy(id,s.id);
		strcpy(name,s.name);
		mark = s.mark;
	}

	void setMark(int);
	bool compare(char*,int);
	bool compare(int);
	char* returnName(void);
	void display(void);


};

void Student::setMark(int c)
{
	mark=c;
}

bool Student::compare(char *string,int a)
{
	unsigned int length=strlen(string),same=0,i;

	if (a==1)
		{
			if (strcmpi(id,string))
				return false;
			else
				return true;
	}
	if (a==2)
		{
			for (i=0;i<length;i++)
			{
				if (string[i] == name[i]) 
					same++;
				else
					same = 0;
			}

			if (same==length)
				return true;
			else 
				return false;
		}
	else
		return false;
}

bool Student::compare(int a)
{
	if (mark==a)
		return true;
	else
		return false;
}

char* Student::returnName()
{
	return name;
}

void Student::display()
{
	cout << setiosflags(ios::left) << setw(14)<<id;
	cout << setw(31)<<name<<setw(6)<<mark<<"\n\n";
}