
/**************************************************************/
/*Programmed by : Vivek Patel**********************************/
/*For Bugs Free feel to contact********************************/
/*Website : www.vivekpatel.cjb.net*****************************/
/*Email : vivek_patel9@rediffmail.com**************************/
/**************************************************************/



class stack{
      int top,stack_arr[MAX];
      public:
      stack(){
	top=-1;
      }
      void push(int);
      int pop();
      int peep(int);
      void change(int,int);
      int status();
      void display();
};

void stack :: push(int item){
     //check for stack overflow
     if(top >= MAX){
	 cout<<"\n\n\t\tSTACK OVERFLOW\n\n";
	 getch();
	 goto end;
     }
     top = top + 1;
     stack_arr[top]=item;
end:
}

int stack :: pop(){
     //check for stack underflow
     if(top < MIN){
	 cout<<"\n\n\t\tSTACK UNDERFLOW\n\n";
	 getch();
	 goto end;
     }
     top = top - 1;
     return(stack_arr[top+1]);
end:
  return(-111);
}

int stack :: peep(int index){
//this function returns index value from
//the top of the stack

     //check for stack underflow
     if((top-index+1) < MIN){
	 cout<<"\n\n\t\tSTACK UNDERFLOW ON PEEP\n\n";
	 getch();
	 goto end;
     }
     return(stack_arr[top-index+1]);
end:
   return(-111);
}

void stack :: change(int index,int item){
//this function changes index value from
//the top of the stack

     //check for stack underflow
     if((top-index+1) < MIN){
	 cout<<"\n\n\t\tSTACK UNDERFLOW ON CHANGE\n\n";
	 getch();
	 goto end;
     }
     stack_arr[top-index+1] = item;
end:
}

int stack :: status(){
//function returns total element
//currently exists in a stack
   return(top+1);
}

void stack :: display(){
     cout<<"\n\t\tElements stored in a stack\n";
     for(int i=top;i>=0;i--){
	  cout<<"\t\t\t"<<stack_arr[i];
	  if(i==top)
	     cout<<"  <-  TOP";
	  else if(i==MIN)
	     cout<<"  <-  BOTTOM";
	  cout<<endl;
     }
     getch();
}
