
/**************************************************************/
/*Programmed by : Vivek Patel**********************************/
/*For Bugs Free feel to contact********************************/
/*Website : www.vivekpatel.cjb.net*****************************/
/*Email : vivek_patel9@rediffmail.com**************************/
/**************************************************************/



struct node{
       int data;
       struct node *next;
};

class stack{
      int top;
      node *head;
      public:
      stack(){
	top=-1;
	head=NULL;
      }
      void push(int);
      int pop();
      int peep(int);
      void change(int,int);
      int status();
      void display();
};

void stack :: push(int item){
     //check for stack overflow
     node *newl;
     if(top >= MAX){
	 cout<<"\n\n\t\tSTACK OVERFLOW\n\n";
	 getch();
	 goto end;
     }
     top = top + 1;
     newl = new node;
     newl->data=item;
     newl->next=head;
     head=newl;
end:
}

int stack :: pop(){
     //check for stack underflow
     node *temp;
     int deldata;
     if(top < MIN){
	 cout<<"\n\n\t\tSTACK UNDERFLOW\n\n";
	 getch();
	 goto end;
     }
     top = top - 1;
     temp = new node;
     temp=head;
     head=head->next;
     deldata = temp->data;
     delete(temp);
     return(deldata);
end:
  return(-111);
}

int stack :: peep(int index){
//this function returns index value from
//the top of the stack
	 int i,peepdata;
	 node *temp;
     //check for stack underflow
     if((top-index) < MIN){
	 cout<<"\n\n\t\tSTACK UNDERFLOW ON PEEP\n\n";
	 getch();
	 goto end;
     }
     temp = head;
     for(i=1;i<top-index;i++)
	temp=temp->next;
     peepdata = temp->data;
     return(peepdata);
end:
   return(-111);
}

void stack :: change(int index,int item){
//this function changes index value from
//the top of the stack
     node *temp;
     int i;
     //check for stack underflow
     if((top-index) < MIN){
	 cout<<"\n\n\t\tSTACK UNDERFLOW ON CHANGE\n\n";
	 getch();
	 goto end;
     }
     temp=head;//storing starting Address of head
     for(i=1;i<top-index;i++)
	head=head->next;
     head->data=item;
     head=temp;//After updating stack, making head points
	       //to it's original location
end:
}

int stack :: status(){
//function returns total element
//currently exists in a stack
   return(top+1);
}

void stack :: display(){
     cout<<"\n\t\tElements stored in a stack\n";
     node *temp;
     for(temp=head;temp!=NULL;temp=temp->next){
	  cout<<"\t\t\t"<<temp->data;
	  if(temp==head)
	     cout<<"  <-  TOP";
	  else if(temp->next==NULL)
	     cout<<"  <-  BOTTOM";
	  cout<<endl;
     }
     getch();
}
