// Kyle Burmark
// 4/19/02
// Implemention file for list class

// Header files

#include <iostream>
#include "list.h"	// List header file
#include "node.h"	// Node header file for linked list operations
#include <cstdlib>	// Provides NULL
using namespace std;


// Used modified code from bag class from programming book by Main and Savitch

// Con/Destructors

list::list()
{
    head_ptr = NULL;
    many_nodes = 0;
    previous_ptr= NULL;
    
}

list::~list()
{
    list_clear(head_ptr);
    many_nodes = 0;
    
    
}

// Mutators

void list::add(const value_type entry)
{
    node *cur_ptr;	// Pointer to point one node ahead of previous_ptr
    
    list_search(head_ptr, cur_ptr, previous_ptr, entry);
    list_insert(head_ptr, previous_ptr, entry);
    ++many_nodes;
}

void list::del(const value_type target)
{
    
    bool found;	    // True false found target variable
    node *cur_ptr;  // Points to current node
    
    found = list_search(head_ptr, cur_ptr, previous_ptr, target);
    
    // Test for action based on value of found
    
    if (found == true)
    {       
	if (previous_ptr != NULL)
	    list_remove(previous_ptr);
	else
	    list_head_remove(head_ptr);
    
	--many_nodes;
    }
    else
    {
	cout << "Can't delete name because it was not found" << endl << endl;
	system ("pause");
    }
    
}

// Accessors

void list::getlist() const
{
    node *loop_ptr; // Pointer to take value of constant head_ptr
    
    // Loop to display names on flight
    
    for (loop_ptr = head_ptr; loop_ptr != NULL; loop_ptr = loop_ptr->link())
    {
	cout << loop_ptr->data() << endl;
    }
    
}

void list::getnum() const
{
    cout << list_length(head_ptr) << " people on the flight" << endl << endl;
}
