/****************************************************************************
	Programmer's Name	: Tani R
	Problem Statement	: To convert a given postfix expression to
				  Infix form.
	List of Functions used	:-
-----------------------------------------------------------------------------
	Function Name			Purpose
-----------------------------------------------------------------------------
     1> post_inf()		converts postfix exprs. to infix
     2> push()			push address onto stack
     3> pop() 			pop address from stack
*****************************************************************************/

	#include<stdio.h>
	#include<ctype.h>
	#include<alloc.h>
	#include<string.h>

	void post_inf(char post[]);
	void push(char *ele);
	char *pop();

	struct stack		//stack to hold addresses of strings
	{
		int top;
		char *st[40];
	}s;


	void main()
	{
		char post[40],*inf;
		clrscr();
		printf("\n\n\t\t\tPOSTFIX TO INFIX CONVERSION\n");
		printf("\n\t\tEnter the postfix expression \n\t\t");
		scanf("%s",&post);
		post_inf(post);
		getch();
	}




	void post_inf(char post[])
	{
		int i,j;
		char *add,*p1,*p2,*newadd;
		char symb[1],temp1[50],temp2[50],inf[50],endprn[]=")\0";
		for(i=0;post[i]!='\0';i++)
		{
			if(isalpha(post[i]) || isdigit(post[i]))
			{
				add=(char *) malloc(2);
				*add=post[i];
				*(add+1)='\0';
				push(add);					//push address of operand
			}
			else
			{
				p1=pop();				//pop first operating string
				j=0;
				while(*p1!='\0')
				{
					temp1[j]=*p1;
					j++;
					p1++;
				}
				temp1[j]='\0';

				p2=pop();			//pop second opperating string
				j=0;
				while(*p2!='\0')
				{
					temp2[j]=*p2;
					j++;
					p2++;
				}
				temp2[j]='\0';
				symb[0]=post[i];
				symb[1]='\0';
				inf[0]='(';
				inf[1]='\0';
				strcat(inf,temp2);			//concating the expessions
				strcat(inf,symb);
				strcat(inf,temp1);
				strcat(inf,endprn);
				newadd=(char *) malloc(50);
				strcpy(newadd,inf);
				push(newadd);		//pushing add. of operated expression onto stack
			}
		}
		printf("\n\t\tThe equivalent infix expression is :\n\t\t");
		for(i=0;inf[i]!='\0';i++)
			printf("%c",inf[i]);
	}



//to push address onto stack

	void push(char *ele)
	{
		s.top++;
		s.st[s.top]=ele;
	}



//to pop address from stack
	char *pop()
	{
		char *elem;
		elem=s.st[s.top];
		s.top--;
		return(elem);
	}


