
/**************************************************************/
/*Programmed by : Vivek Patel**********************************/
/*For Bugs Free feel to contact********************************/
/*Website : www.vivekpatel.cjb.net*****************************/
/*Email : vivek_patel9@rediffmail.com**************************/
/**************************************************************/



class stack{
			int top1,top2,stno,stack_arr[MAX];
			public:
			stack(){
				 top1=MIN-1;
				 top2=MAX;
			}
			void push(int,int);
			int pop(int);
			int peep(int,int);
			void change(int,int,int);
			int status(int);
			void display();
};

void stack :: push(int item,int stno){
		 //check for stack overflow
		 if(top1+1 >= top2){
	 cout<<"\n\n\t\tSTACK OVERFLOW\n\n";
	 getch();
	 goto end;
		 }
		 else if(stno==0){
		top1 = top1 + 1;
		stack_arr[top1]=item;
		 }
		 else if(stno==1){
		top2 = top2 - 1;
		stack_arr[top2]=item;
		 }
end:
}

int stack :: pop(int stno){
		 //check for stack underflow
		 if((stno==0) && (top1 < MIN)){
	 cout<<"\n\n\t\tSTACK UNDERFLOW\n\n";
	 getch();
	 goto end;
		 }
		 else if((stno==1) && (top2 >= MAX)){
	 cout<<"\n\n\t\tSTACK UNDERFLOW\n\n";
	 getch();
	 goto end;
		 }

		 if(stno==0){
		top1 = top1 - 1;
		return(stack_arr[top1+1]);
		 }
		 else{
		top2 = top2 + 1;
		return(stack_arr[top2-1]);
		 }
end:
	return(-111);
}


int stack :: peep(int index,int stno){
//this function returns index value from
//the top of the stack

		 //check for stack underflow
		 if(stno==0){
				 if((top1-index+1) < MIN){
				 cout<<"\n\n\t\tSTACK UNDERFLOW ON PEEP\n\n";
				 getch();
				 goto end;
				}
				return(stack_arr[top1-index+1]);
		 }
		 else{
				 if((top2+index-1) >= MAX){
				 cout<<"\n\n\t\tSTACK UNDERFLOW ON PEEP\n\n";
				 getch();
				 goto end;
				}
				return(stack_arr[top2+index-1]);
		 }
end:
	 return(-111);
}

void stack :: change(int index,int item,int stno){
//this function changes index value from
//the top of the stack

		 //check for stack underflow
		 if(stno==0){
				 if((top1-index+1) < MIN){
				 cout<<"\n\n\t\tSTACK UNDERFLOW ON CHANGE\n\n";
				 getch();
				 goto end;
				}
			 stack_arr[top1-index+1]=item;
		 }
		 else{
				 if((top2+index-1) >= MAX){
				 cout<<"\n\n\t\tSTACK UNDERFLOW ON CHANGE\n\n";
				 getch();
				 goto end;
				}
				stack_arr[top2+index-1]=item;
		 }
end:
}

int stack :: status(int stno){
//function returns total element
//currently exists in a stack
	 if(stno==0)
		return(top1+1);
	 else
		return(MAX-top2);
}


void stack :: display(){
		 int i;
		 cout<<"\n\t\tElements stored in a stack\n";
		 cout<<"\n\t\tSTACK1\n";
		 for(i=top1;i>=0;i--){
		cout<<"\t\t\t"<<stack_arr[i];
		if(i==top1)
			 cout<<"  <-  TOP";
		else if(i==MIN)
			 cout<<"  <-  BOTTOM";
		cout<<endl;
		 }
		 cout<<"\n\t\tSTACK2\n";
		 for(i=top2;i<MAX;i++){
		cout<<"\t\t\t"<<stack_arr[i];
		if(i==top2)
			 cout<<"  <-  TOP";
		else if(i==MAX-1)
			 cout<<"  <-  BOTTOM";
		cout<<endl;
		 }
		 getch();
}
