//Infix to postfix
//paranthesized


/**************************************************************/
/*Programmed by : Vivek Patel**********************************/
/*For Bugs Free feel to contact********************************/
/*Website : www.vivekpatel.cjb.net*****************************/
/*Email : vivek_patel9@rediffmail.com**************************/
/**************************************************************/



#include <iostream.h>
#include <stdlib.h>  //for exit()
#include <conio.h>

class revpol{
      int top,rank;
      char *stack_arr,*polish,*infix;
      public:
      int f(char);  //Input precedence function
      int g(char);  //Stack precedence function
      int r(char);  //rank function
      void push(char);
      char pop();
      char *concat(char *,char);
      void suffix();//infix to suffix conversion function
};

int revpol :: f(char inputchar){
     if(inputchar==')')
	  return(0);
     else if(inputchar=='+' || inputchar=='-')
	  return(1);
     else if(inputchar=='*' || inputchar=='/')
	  return(3);
     else if(inputchar=='^')
	  return(6);
     else if(inputchar>='a' || inputchar<='z')
	  return(7);
     else if(inputchar>='A' || inputchar<='Z')
	  return(7);
     else if(inputchar=='(')
	  return(9);
     else
	  return(-99);  //for error
}

int revpol :: g(char inputchar){
     if(inputchar=='(')
	  return(0);
     else if(inputchar=='+' || inputchar=='-')
	  return(2);
     else if(inputchar=='*' || inputchar=='/')
	  return(4);
     else if(inputchar=='^')
	  return(5);
     else if(inputchar>='a' || inputchar<='z')
	  return(8);
     else if(inputchar>='A' || inputchar<='Z')
	  return(8);
     else
	  return(-99);  //for error
}


int revpol :: r(char inputchar){
     if(inputchar=='+' || inputchar=='-' || inputchar=='*' || inputchar=='/'|| inputchar=='^')
	  return(-1);
     else if(inputchar>='a' || inputchar<='z')
	  return(1);
     else if(inputchar>='A' || inputchar<='Z')
	  return(1);
     else
	  return(-99);  //for error
}


void revpol :: push(char charin){
     top++;
     stack_arr[top]=charin;
}

char revpol :: pop(){
     char popdata;
     popdata=stack_arr[top];
     top--;
     return(popdata);
}

char * revpol :: concat(char *polish,char temp){
     int i;
     for(i=0;polish[i]!='\0';i++);
     polish[i]=temp;
     polish[i+1]='\0';
     return(polish);
}

void revpol :: suffix(){
     int i;
     char next,temp;

     //initialize the stack
     top=0;
     stack_arr[top]='(';

     //Intialize output string and rank count
     polish="";
     rank=0;

     cout<<"\n\t*****INFIX TO POSTFIX*****\n";
     cout<<"\t       Paranthesized";
     cout<<"\n\n\tEnter Infix string ( \")\" sign @ end) : ";
     cin>>infix;

     //Remove symbols with greater precedence from stack
     for(i=0;infix[i]!='\0';i++){
	 //obtain next input symbol
	 next=infix[i];
	 if(top<0){
	    cout<<"\n\n\tInvali Infix";
	    getch();
	    exit(1);
	 }
	 while(f(next) < g(stack_arr[top])){
	       temp=pop();
	       polish=concat(polish,temp);
	       rank = rank + r(temp);
	       if(rank<1){
		  cout<<"\n\n\tInvalid Infix";
		  getch();
		  exit(1);
	       }
	 }
	 //Are there matching parentheses?
	 if(f(next) != g(stack_arr[top]))
	     push(next);
	 else
	     temp=pop();  //here value in temp is of no use
     }


      //Check whether expression is invalid
	  if(rank!=1 || top!=-1)
	     cout<<"\n\n\tInvalid Infix";
	  else{
	     cout<<"\n\n\tValid Infix";
	     cout<<"\n\n\tSuffix : "<<polish;
	  }
}

void main(){
     clrscr();
     revpol obj;
     obj.suffix();
     getch();
}

