//Infix to postfix
//unparanthesized


/**************************************************************/
/*Programmed by : Vivek Patel**********************************/
/*For Bugs Free feel to contact********************************/
/*Website : www.vivekpatel.cjb.net*****************************/
/*Email : vivek_patel9@rediffmail.com**************************/
/**************************************************************/



#include <iostream.h>
#include <stdlib.h>  //for exit()
#include <conio.h>

class revpol{
      int top,rank;
      char *stack_arr,*polish,*infix;
      public:
      int f(char);  //precedence function
      int r(char);  //rank function
      void push(char);
      char pop();
      char *concat(char *,char);
      void suffix();//infix to suffix conversion function
};

int revpol :: f(char inputchar){
     if(inputchar=='#')
	  return(0);
     if(inputchar=='+' || inputchar=='-')
	  return(1);
     else if(inputchar=='*' || inputchar=='/')
	  return(2);
     else if(inputchar>='a' || inputchar<='z')
	  return(3);
     else if(inputchar>='A' || inputchar<='Z')
	  return(3);
     else
	  return(-99);  //for error
}

int revpol :: r(char inputchar){
     if(inputchar=='+' || inputchar=='-' || inputchar=='*' || inputchar=='/')
	  return(-1);
     else if(inputchar>='a' || inputchar<='z')
	  return(1);
     else if(inputchar>='A' || inputchar<='Z')
	  return(1);
     else
	  return(-99);  //for error
}


void revpol :: push(char charin){
     top++;
     stack_arr[top]=charin;
}

char revpol :: pop(){
     char popdata;
     popdata=stack_arr[top];
     top--;
     return(popdata);
}

char * revpol :: concat(char *polish,char temp){
     int i;
     for(i=0;polish[i]!='\0';i++);
     polish[i]=temp;
     polish[i+1]='\0';
     return(polish);
}

void revpol :: suffix(){
     int i;
     char next,temp;

     //initialize the stack
     top=0;
     stack_arr[top]='#';

     //Intialize output string and rank count
     polish="";
     rank=0;

     cout<<"\n\t*****INFIX TO POSTFIX*****\n";
     cout<<"\t      UNParanthesized";
     cout<<"\n\n\tEnter Infix string (# sign @ end) : ";
     cin>>infix;

     //Remove symbols with greater or equal precedence from stack
     for(i=0;infix[i]!='#';i++){
	 //obtain next input symbol
	 next=infix[i];
	 while(f(next) <= f(stack_arr[top])){
	       temp=pop();
	       polish=concat(polish,temp);
	       rank = rank + r(temp);
	       if(rank<1){
		  cout<<"\n\n\tInvalid Infix";
		  getch();
		  exit(1);
	       }
	 }
	 //push the current symbol onto stack
	 push(next);
     }

     //Remove remaining elements from stack
     while(stack_arr[top]!='#'){
	  temp=pop();
	  polish=concat(polish,temp);
	  rank=rank+r(temp);
	  if(rank<1){
	     cout<<"\n\n\tInvalid Infix";
	     getch();
	     exit(1);
	   }
      }

      //Check whether expression is invalid
	  if(rank!=1)
	     cout<<"\n\n\tInvalid Infix";
	  else{
	     cout<<"\n\n\tValid Infix";
	     cout<<"\n\n\tSuffix : "<<polish;
	  }
}

void main(){
     clrscr();
     revpol obj;
     obj.suffix();
     getch();
}

